# Monthly assessment

library(tidyverse)

path_data <- message("insert path here")
path_workspaces <- message("insert path here")

load(file = paste0(path_workspaces,"Vulnerability_monthly_mv3_only_driver.RData")) # Vulnerability data with soil moisture from ESA CCI from Vulnerability_analysis.Rmd
load(file=paste0(path_workspaces,"Regional_indices.RData")) # from Regional_comparisons.r
load(file = paste0(path_workspaces,"Landcovers.RData")) # from Land_cover.Rmd
# Reduced set where pixels with land cover change are excluded
load(file=paste0(path_workspaces,"locat_red.RData")) # from Land_cover.Rmd

# First revision ####
reg_id_red <- gsub("BAL", "Balkan Peninsula", reg_id_red)
reg_id_red <- gsub("IAF", "Italy and France", reg_id_red)
reg_id_red <- gsub("IBE", "Iberian Peninsula", reg_id_red)
reg_id_red <- gsub("NWA", "Northwestern Africa", reg_id_red)
reg_id_red <- gsub("SEM", "Southeastern Mediterranean", reg_id_red)
reg_id_red <- gsub("TAC", "Turkey and Cyprus", reg_id_red)
####

locat <- locat_red
lcs <- lcs_red
reg_id <- reg_id_red
lcs_aggr <- lcs_aggr_red
locat <- locat[lcs_aggr_red!="Water bodies" & lcs_aggr_red!="Urban areas"] # exclude Water bodies and Urban areas
lcs <- lcs[lcs_aggr_red!="Water bodies" & lcs_aggr_red!="Urban areas"]
reg_id <- reg_id[lcs_aggr_red!="Water bodies" & lcs_aggr_red!="Urban areas"]
lcs_aggr <- lcs_aggr[lcs_aggr_red!="Water bodies" & lcs_aggr_red!="Urban areas"]

nr_lc <- length(unique(lcs_aggr)) + 1 # One additional land cover for "All", i.e. all land covers combined

nexp_list <- list(imp_vul_temp_m_Jan = imp_vul_temp_Jan[[1]], imp_vul_temp_m_Feb = imp_vul_temp_Feb[[1]], imp_vul_temp_m_Mar = imp_vul_temp_Mar[[1]],
                  imp_vul_temp_m_Apr = imp_vul_temp_Apr[[1]], imp_vul_temp_m_May = imp_vul_temp_May[[1]], imp_vul_temp_m_Jun = imp_vul_temp_Jun[[1]],
                  imp_vul_temp_m_Jul = imp_vul_temp_Jul[[1]], imp_vul_temp_m_Aug = imp_vul_temp_Aug[[1]], imp_vul_temp_m_Sep = imp_vul_temp_Sep[[1]],
                  imp_vul_temp_m_Oct = imp_vul_temp_Oct[[1]], imp_vul_temp_m_Nov = imp_vul_temp_Nov[[1]], imp_vul_temp_m_Dec = imp_vul_temp_Dec[[1]],
                  imp_vul_sm_m_Jan = imp_vul_sm_Jan[[1]], imp_vul_sm_m_Feb = imp_vul_sm_Feb[[1]], imp_vul_sm_m_Mar = imp_vul_sm_Mar[[1]],
                  imp_vul_sm_m_Apr = imp_vul_sm_Apr[[1]], imp_vul_sm_m_May = imp_vul_sm_May[[1]], imp_vul_sm_m_Jun = imp_vul_sm_Jun[[1]],
                  imp_vul_sm_m_Jul = imp_vul_sm_Jul[[1]], imp_vul_sm_m_Aug = imp_vul_sm_Aug[[1]], imp_vul_sm_m_Sep = imp_vul_sm_Sep[[1]],
                  imp_vul_sm_m_Oct = imp_vul_sm_Oct[[1]], imp_vul_sm_m_Nov = imp_vul_sm_Nov[[1]], imp_vul_sm_m_Dec = imp_vul_sm_Dec[[1]])
exp_list <- list(imp_vul_temp_m_Jan = imp_vul_temp_Jan[[2]], imp_vul_temp_m_Feb = imp_vul_temp_Feb[[2]], imp_vul_temp_m_Mar = imp_vul_temp_Mar[[2]],
                 imp_vul_temp_m_Apr = imp_vul_temp_Apr[[2]], imp_vul_temp_m_May = imp_vul_temp_May[[2]], imp_vul_temp_m_Jun = imp_vul_temp_Jun[[2]],
                 imp_vul_temp_m_Jul = imp_vul_temp_Jul[[2]], imp_vul_temp_m_Aug = imp_vul_temp_Aug[[2]], imp_vul_temp_m_Sep = imp_vul_temp_Sep[[2]],
                 imp_vul_temp_m_Oct = imp_vul_temp_Oct[[2]], imp_vul_temp_m_Nov = imp_vul_temp_Nov[[2]], imp_vul_temp_m_Dec = imp_vul_temp_Dec[[2]],
                 imp_vul_sm_m_Jan = imp_vul_sm_Jan[[2]], imp_vul_sm_m_Feb = imp_vul_sm_Feb[[2]], imp_vul_sm_m_Mar = imp_vul_sm_Mar[[2]],
                 imp_vul_sm_m_Apr = imp_vul_sm_Apr[[2]], imp_vul_sm_m_May = imp_vul_sm_May[[2]], imp_vul_sm_m_Jun = imp_vul_sm_Jun[[2]],
                 imp_vul_sm_m_Jul = imp_vul_sm_Jul[[2]], imp_vul_sm_m_Aug = imp_vul_sm_Aug[[2]], imp_vul_sm_m_Sep = imp_vul_sm_Sep[[2]],
                 imp_vul_sm_m_Oct = imp_vul_sm_Oct[[2]], imp_vul_sm_m_Nov = imp_vul_sm_Nov[[2]], imp_vul_sm_m_Dec = imp_vul_sm_Dec[[2]])


mean_nexp_list <- vector("list",length(nexp_list))
mean_exp_list <- vector("list",length(exp_list))
for (i in 1:length(exp_list)){
  mean_nexp_list[[i]] <- sapply(1:length(lcs_aggr), function(x) mean(nexp_list[[i]][[x]],na.rm=T))
  mean_exp_list[[i]] <- sapply(1:length(lcs_aggr), function(x) mean(exp_list[[i]][[x]],na.rm=T))
}
names(mean_nexp_list) <- names(nexp_list); names(mean_exp_list) <- names(exp_list)

mean_nexp <- as.data.frame(list(mean_nexp_list, Region_ID=reg_id, Landcover=lcs_aggr))
mean_exp <- as.data.frame(list(mean_exp_list, Region_ID=reg_id, Landcover=lcs_aggr))
mean_nexp <- mean_nexp %>% pivot_longer(cols = colnames((mean_nexp)[1:length(nexp_list)]),
                                        names_to = c("Type", "Month"), names_sep = "_m_", values_to = "non-extreme") # arrange in ggplot2 preferred format
mean_exp <- mean_exp %>% pivot_longer(cols = colnames((mean_exp)[1:length(nexp_list)]),
                                      names_to = c("Type", "Month"), names_sep = "_m_", values_to = "Extreme") # arrange in ggplot2 preferred format
mean_nexp_exp <- cbind(mean_nexp, mean_exp$Extreme)
names(mean_nexp_exp)[6] <- "Extreme"


# vul_mon contains every pixel for each month and impact type and the corresponding region and landcover
vul_mon <- data.frame(imp_vul_temp_m_Jan = imp_vul_temp_Jan[[3]], imp_vul_temp_m_Feb = imp_vul_temp_Feb[[3]], imp_vul_temp_m_Mar = imp_vul_temp_Mar[[3]],
                      imp_vul_temp_m_Apr = imp_vul_temp_Apr[[3]], imp_vul_temp_m_May = imp_vul_temp_May[[3]], imp_vul_temp_m_Jun = imp_vul_temp_Jun[[3]],
                      imp_vul_temp_m_Jul = imp_vul_temp_Jul[[3]], imp_vul_temp_m_Aug = imp_vul_temp_Aug[[3]], imp_vul_temp_m_Sep = imp_vul_temp_Sep[[3]],
                      imp_vul_temp_m_Oct = imp_vul_temp_Oct[[3]], imp_vul_temp_m_Nov = imp_vul_temp_Nov[[3]], imp_vul_temp_m_Dec = imp_vul_temp_Dec[[3]],
                      imp_vul_sm_m_Jan = imp_vul_sm_Jan[[3]], imp_vul_sm_m_Feb = imp_vul_sm_Feb[[3]], imp_vul_sm_m_Mar = imp_vul_sm_Mar[[3]],
                      imp_vul_sm_m_Apr = imp_vul_sm_Apr[[3]], imp_vul_sm_m_May = imp_vul_sm_May[[3]], imp_vul_sm_m_Jun = imp_vul_sm_Jun[[3]],
                      imp_vul_sm_m_Jul = imp_vul_sm_Jul[[3]], imp_vul_sm_m_Aug = imp_vul_sm_Aug[[3]], imp_vul_sm_m_Sep = imp_vul_sm_Sep[[3]],
                      imp_vul_sm_m_Oct = imp_vul_sm_Oct[[3]], imp_vul_sm_m_Nov = imp_vul_sm_Nov[[3]], imp_vul_sm_m_Dec = imp_vul_sm_Dec[[3]],
                      Region_ID = reg_id, Landcover = lcs_aggr)
vul_mon <- vul_mon %>% pivot_longer(cols = names(nexp_list),
                                    names_to = c("Type", "Month"), names_sep = "_m_", values_to = "Vulnerability") # arrange in ggplot2 preferred format
levels(vul_mon$Region_ID) <- c(levels(vul_mon$Region_ID),"None")
vul_mon$Region_ID[is.na(vul_mon$Region_ID)] <- "None"


# Add landcover "All" for the average behaviour
mean_nexp_exp_one_lc <- mean_nexp_exp
mean_nexp_exp_one_lc$Landcover <- "All land cover classes"
mean_nexp_exp_lc <- bind_rows(mean_nexp_exp, mean_nexp_exp_one_lc)

vul_mon_one_lc <- vul_mon
vul_mon_one_lc$Landcover <- "All land cover classes"
vul_mon_lc_all <- bind_rows(vul_mon, vul_mon_one_lc)

# Add Region "All" for the average behaviour
mean_nexp_exp_one_reg <- mean_nexp_exp
mean_nexp_exp_one_reg$Region_ID <- "All subregions"
mean_nexp_exp_reg <- bind_rows(mean_nexp_exp, mean_nexp_exp_one_reg)

vul_mon_one_reg <- vul_mon
vul_mon_one_reg$Region_ID <- "All subregions"
vul_mon_reg_all <- bind_rows(vul_mon, vul_mon_one_reg)

give.n <- function(x){
  return(c(y = median(x)*1.05, label = length(x))) 
}

# Land cover --------------------------------------------------------------

nexp_exp_lc <- data.frame(matrix(data=NA,nrow=12*2*nr_lc, ncol=8)) # 12 months * 2 Types * 14 Landcover
colnames(nexp_exp_lc) <- c("Landcover", "Type", "Month", "Sign_of_vulnerability", "p_value_t_test", "Significance_t_test", "p_value_Wilcox", "Significance_Wilcox")
i <- 1
for (mon in c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")){
  for (typ in c("imp_vul_sm","imp_vul_temp")){
    for (lcov in sort(unique(mean_nexp_exp_lc$Landcover))) {
      sub <- mean_nexp_exp_lc %>% filter(Month == mon & Landcover == lcov & Type == typ)
      nexp_exp_lc[i,1] <- lcov
      nexp_exp_lc[i,2] <- typ
      nexp_exp_lc[i,3] <- mon
      if (length(sub$`non-extreme`)!=0 | length(sub$`Extreme`!=0)){
        nexp_exp_lc[i,4] <- sign(mean(sub$`non-extreme`, na.rm=T) - mean(sub$Extreme, na.rm=T))
        nexp_exp_lc[i,5] <- t.test(sub$`non-extreme`, sub$Extreme)$p.value
        nexp_exp_lc[i,7] <- wilcox.test(sub$`non-extreme`, sub$Extreme)$p.value
      }
      i <- i + 1
    }
  }
}
nexp_exp_lc[,6] <- ifelse(nexp_exp_lc[,5] < 0.05, 1, 0)
nexp_exp_lc[,6][nexp_exp_lc[,5] < 0.01] <- 2
nexp_exp_lc[,6][nexp_exp_lc[,5] < 0.001] <- 3
nexp_exp_lc[,8] <- ifelse(nexp_exp_lc[,7] < 0.05, 1, 0)
nexp_exp_lc[,8][nexp_exp_lc[,7] < 0.01] <- 2
nexp_exp_lc[,8][nexp_exp_lc[,7] < 0.001] <- 3
nexp_exp_lc$p_value_adj_Wilcox <- NA
nexp_exp_lc$p_value_adj_Wilcox[nexp_exp_lc$Landcover!="All land cover classes"] <- p.adjust(nexp_exp_lc$p_value_Wilcox[nexp_exp_lc$Landcover!="All land cover classes"], "fdr")
nexp_exp_lc$p_value_adj_Wilcox[nexp_exp_lc$Landcover=="All land cover classes"] <- p.adjust(nexp_exp_lc$p_value_Wilcox[nexp_exp_lc$Landcover=="All land cover classes"], "fdr")
nexp_exp_lc$Significance_adj_Wilcox <- ifelse(nexp_exp_lc[,9] < 0.05, 1, 0)
nexp_exp_lc[,10][nexp_exp_lc[,9] < 0.01] <- 2
nexp_exp_lc[,10][nexp_exp_lc[,9] < 0.001] <- 3

# export for LaTeX
nexp_exp_lc_simp <- nexp_exp_lc[,c(1,2,3,9)]
nexp_exp_lc_sm <- nexp_exp_lc_simp %>% filter(Type=="imp_vul_sm") 
lc_p_val_sm <- pivot_wider(data=nexp_exp_lc_sm, id_cols="Landcover", names_from = "Month", values_from = "p_value_adj_Wilcox")
lc_p_val_sm[,2:13][lc_p_val_sm[,2:13] < 1e-10] <- 0 # set extremely small values to 0
lc_p_val_sm[,2:13] <- signif(lc_p_val_sm[,2:13], digits = 2)
nexp_exp_lc_temp <- nexp_exp_lc_simp %>% filter(Type=="imp_vul_temp") 
lc_p_val_temp <- pivot_wider(data=nexp_exp_lc_temp, id_cols="Landcover", names_from = "Month", values_from = "p_value_adj_Wilcox")
lc_p_val_temp[,2:13][lc_p_val_temp[,2:13] < 1e-10] <- 0 # set extremely small values to 0
lc_p_val_temp[,2:13] <- signif(lc_p_val_temp[,2:13], digits = 2)
write.table(lc_p_val_sm, file = "./Code/Workspaces/lc_p_val_sm.csv", sep="&", dec=".", row.names = F)
write.table(lc_p_val_temp, file = "./Code/Workspaces/lc_p_val_temp.csv", sep="&", dec=".", row.names = F)

nexp_exp_lc <- nexp_exp_lc %>% mutate(Significant_sign=Sign_of_vulnerability * Significance_adj_Wilcox)
nexp_exp_lc$Month  <- factor(nexp_exp_lc$Month, levels = c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")) # order correctly
mean_nexp_exp_lc$Month  <- factor(mean_nexp_exp_lc$Month, levels = c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"))
vul_mon_lc_all$Month  <- factor(vul_mon_lc_all$Month, levels = c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"))
nexp_exp_lc$Sign_color <- rep(NA,length(nexp_exp_lc$Significant_sign)) # Provide specific colors
nexp_exp_lc$Sign_color[nexp_exp_lc$Significant_sign==0] <- "grey"
nexp_exp_lc$Sign_color[nexp_exp_lc$Significant_sign==1] <- "LightPink"
nexp_exp_lc$Sign_color[nexp_exp_lc$Significant_sign==-1] <- "CadetBlue1"
nexp_exp_lc$Sign_color[nexp_exp_lc$Significant_sign==2] <- "LightCoral"
nexp_exp_lc$Sign_color[nexp_exp_lc$Significant_sign==-2] <- "SkyBlue2"
nexp_exp_lc$Sign_color[nexp_exp_lc$Significant_sign==3] <- "red"
nexp_exp_lc$Sign_color[nexp_exp_lc$Significant_sign==-3] <- "navy"


# Regions -----------------------------------------------------------------


levels(mean_nexp_exp_reg$Region_ID) <- c(levels(mean_nexp_exp_reg$Region_ID),"None")
mean_nexp_exp_reg$Region_ID[is.na(mean_nexp_exp_reg$Region_ID)] <- "None"
nexp_exp_reg <- data.frame(matrix(data=NA,nrow=12*2*6, ncol=8)) # 12 months * 2 Types * 6 subregions
colnames(nexp_exp_reg) <- c("Region_ID", "Type", "Month", "Sign_of_vulnerability", "p_value_t_test", "Significance_t_test", "p_value_Wilcox", "Significance_Wilcox")
i <- 1
for (mon in c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")){
  for (typ in c("imp_vul_sm","imp_vul_temp")){
    for (reg in sort(unique(mean_nexp_exp_reg$Region_ID))) {
      sub <- mean_nexp_exp_reg %>% filter(Month == mon & Region_ID == reg & Type == typ)
      nexp_exp_reg[i,1] <- reg
      nexp_exp_reg[i,2] <- typ
      nexp_exp_reg[i,3] <- mon
      if (length(sub$`non-extreme`)!=0 | length(sub$`Extreme`!=0)){
        nexp_exp_reg[i,4] <- sign(mean(sub$`non-extreme`, na.rm=T) - mean(sub$Extreme, na.rm=T))
        nexp_exp_reg[i,5] <- t.test(sub$`non-extreme`, sub$Extreme)$p.value
        nexp_exp_reg[i,7] <- wilcox.test(sub$`non-extreme`, sub$Extreme)$p.value
      }
      i <- i + 1
    }
  }
}
nexp_exp_reg[,6] <- ifelse(nexp_exp_reg[,5] < 0.05, 1, 0)
nexp_exp_reg[,6][nexp_exp_reg[,5] < 0.01] <- 2
nexp_exp_reg[,6][nexp_exp_reg[,5] < 0.001] <- 3
nexp_exp_reg[,8] <- ifelse(nexp_exp_reg[,7] < 0.05, 1, 0)
nexp_exp_reg[,8][nexp_exp_reg[,7] < 0.01] <- 2
nexp_exp_reg[,8][nexp_exp_reg[,7] < 0.001] <- 3
nexp_exp_reg$p_value_adj_Wilcox <- NA
nexp_exp_reg$p_value_adj_Wilcox[nexp_exp_reg$Region_ID!="All subregions"] <- p.adjust(nexp_exp_reg$p_value_Wilcox[nexp_exp_reg$Region_ID!="All subregions"], "fdr")
nexp_exp_reg$p_value_adj_Wilcox[nexp_exp_reg$Region_ID=="All subregions"] <- p.adjust(nexp_exp_reg$p_value_Wilcox[nexp_exp_reg$Region_ID=="All subregions"], "fdr")
nexp_exp_reg$Significance_adj_Wilcox <- ifelse(nexp_exp_reg[,9] < 0.05, 1, 0)
nexp_exp_reg[,10][nexp_exp_reg[,9] < 0.01] <- 2
nexp_exp_reg[,10][nexp_exp_reg[,9] < 0.001] <- 3

# export for LaTeX
nexp_exp_reg_simp <- nexp_exp_reg[,c(1,2,3,9)]
nexp_exp_reg_sm <- nexp_exp_reg_simp %>% filter(Type=="imp_vul_sm") 
reg_p_val_sm <- pivot_wider(data=nexp_exp_reg_sm, id_cols="Region_ID", names_from = "Month", values_from = "p_value_adj_Wilcox")
reg_p_val_sm[,2:13][reg_p_val_sm[,2:13] < 1e-10] <- 0 # set extremely small values to 0
reg_p_val_sm[,2:13] <- signif(reg_p_val_sm[,2:13], digits = 2)
nexp_exp_reg_temp <- nexp_exp_reg_simp %>% filter(Type=="imp_vul_temp") 
reg_p_val_temp <- pivot_wider(data=nexp_exp_reg_temp, id_cols="Region_ID", names_from = "Month", values_from = "p_value_adj_Wilcox")
reg_p_val_temp[,2:13][reg_p_val_temp[,2:13] < 1e-10] <- 0 # set extremely small values to 0
reg_p_val_temp[,2:13] <- signif(reg_p_val_temp[,2:13], digits = 2)
write.table(reg_p_val_sm, file = "./Code/Workspaces/reg_p_val_sm.csv", sep="&", dec=".", row.names = F)
write.table(reg_p_val_temp, file = "./Code/Workspaces/reg_p_val_temp.csv", sep="&", dec=".", row.names = F)

nexp_exp_reg <- nexp_exp_reg %>% mutate(Significant_sign=Sign_of_vulnerability * Significance_adj_Wilcox)
nexp_exp_reg$Month  <- factor(nexp_exp_reg$Month, levels = c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")) # order correctly
mean_nexp_exp_reg$Month  <- factor(mean_nexp_exp_reg$Month, levels = c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"))
vul_mon_reg_all$Month  <- factor(vul_mon_reg_all$Month, levels = c("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"))
nexp_exp_reg$Sign_color <- rep(NA,length(nexp_exp_reg$Significant_sign)) # Provide specific colors
nexp_exp_reg$Sign_color[nexp_exp_reg$Significant_sign==0] <- "grey"
nexp_exp_reg$Sign_color[nexp_exp_reg$Significant_sign==1] <- "LightPink"
nexp_exp_reg$Sign_color[nexp_exp_reg$Significant_sign==-1] <- "CadetBlue1"
nexp_exp_reg$Sign_color[nexp_exp_reg$Significant_sign==2] <- "LightCoral"
nexp_exp_reg$Sign_color[nexp_exp_reg$Significant_sign==-2] <- "SkyBlue2"
nexp_exp_reg$Sign_color[nexp_exp_reg$Significant_sign==3] <- "red"
nexp_exp_reg$Sign_color[nexp_exp_reg$Significant_sign==-3] <- "navy"



# Plot as time series -----------------------------------------------------


# Landcover ---------------------------------------------------------------

vul_mon_lc <- group_by(vul_mon_lc_all, Month, Landcover)

for (typ in c("imp_vul_sm","imp_vul_temp")){
  vul_mon_lc_med <- vul_mon_lc %>% filter(Type==typ) %>% summarize(Median_Vulnerability = median(Vulnerability, na.rm=T))
  vul_mon_lc_low <- vul_mon_lc %>% filter(Type==typ) %>% summarize(IQR_low = quantile(Vulnerability, 1/4, na.rm=T))
  vul_mon_lc_high <- vul_mon_lc %>% filter(Type==typ) %>% summarize(IQR_high = quantile(Vulnerability, 3/4, na.rm=T))
  col_vec <- nexp_exp_lc %>% filter(Type==typ)
  col_vec <-  col_vec[order(col_vec$Month),] # order so that the colors match
  vul_mon_lc_stat <- data.frame(vul_mon_lc_med, IQR_low = vul_mon_lc_low$IQR_low, IQR_high = vul_mon_lc_high$IQR_high, col_vec %>% select(Sign_color))
  vul_mon_lc_stat <- group_by(vul_mon_lc_stat, Month, Landcover)
  print(ggplot(vul_mon_lc_stat)+ 
          geom_vline(aes(xintercept = Month), size = 30, color = vul_mon_lc_stat$Sign_color)+
          geom_line(aes(Month, Median_Vulnerability, group=1), size=1.4)+
          # geom_errorbar(aes(x = Month, ymax = IQR_high, ymin = IQR_low, group=1))+
          geom_line(aes(Month, IQR_high, group=1), color="white", size=1.4, alpha=0.6)+
          geom_line(aes(Month, IQR_low, group=1), color="white", size=1.4, alpha=0.6)+
          labs(title=paste("Time series of vulnerability of all land covers faceted for each month for",typ))+
          facet_wrap(~ Landcover, nrow=nr_lc,ncol=1))
  ggsave(filename=paste0("./Output/Time_series_vulnerability_land_cover_month_colored_",typ,"_2sample_wilcox_test.png"), width = 12, height = 17)
}


# Regions -----------------------------------------------------------------


vul_mon_reg <- group_by(vul_mon_reg_all, Month, Region_ID)

for (typ in c("imp_vul_sm","imp_vul_temp")){
  vul_mon_reg_med <- vul_mon_reg %>% filter(Type==typ) %>% summarize(Median_Vulnerability = median(Vulnerability, na.rm=T))
  vul_mon_reg_low <- vul_mon_reg %>% filter(Type==typ) %>% summarize(IQR_low = quantile(Vulnerability, 1/4, na.rm=T))
  vul_mon_reg_high <- vul_mon_reg %>% filter(Type==typ) %>% summarize(IQR_high = quantile(Vulnerability, 3/4, na.rm=T))
  col_vec <- nexp_exp_reg %>% filter(Type==typ)
  col_vec <-  col_vec[order(col_vec$Month),] # order so that the colors match
  vul_mon_reg_stat <- data.frame(vul_mon_reg_med, IQR_low = vul_mon_reg_low$IQR_low, IQR_high = vul_mon_reg_high$IQR_high, col_vec %>% select(Sign_color))
  vul_mon_reg_stat <- group_by(vul_mon_reg_stat, Month, Region_ID)
  print(ggplot(vul_mon_reg_stat)+ 
          geom_vline(aes(xintercept = Month), size = 30, color = vul_mon_reg_stat$Sign_color)+
          geom_line(aes(Month, Median_Vulnerability, group=1), size=1.4)+
          # geom_errorbar(aes(x = Month, ymax = IQR_high, ymin = IQR_low, group=1))+
          geom_line(aes(Month, IQR_high, group=1), color="white", size=1.4, alpha=0.8)+
          geom_line(aes(Month, IQR_low, group=1), color="white", size=1.4, alpha=0.8)+
          labs(title=paste("Time series of vulnerability of all land covers faceted for each month for",typ))+
          facet_wrap(~ Region_ID, nrow=7,ncol=1))
  ggsave(filename=paste0("./Output/Time_series_vulnerability_subregion_month_colored_",typ,"_2sample_wilcox_test.png"), width = 12, height = 13)
}



# Bivariate case -----------------------------------------------------------------


# Landcover ---------------------------------------------------------------
nexp_exp_lc_temp <- filter(nexp_exp_lc, Type == "imp_vul_temp")
nexp_exp_lc_sm <- filter(nexp_exp_lc, Type == "imp_vul_sm")

sign_temp_sm <- rep(NA, nr_lc*12)
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == 0 & sign(nexp_exp_lc_sm$Significant_sign) == 0] <- 0
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == 0 & sign(nexp_exp_lc_sm$Significant_sign) == 1] <- 5
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == 0 & sign(nexp_exp_lc_sm$Significant_sign) == -1] <- 6
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == 1 & sign(nexp_exp_lc_sm$Significant_sign) == 0] <- 7
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == 1 & sign(nexp_exp_lc_sm$Significant_sign) == 1] <- 1 # cold and dry
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == 1 & sign(nexp_exp_lc_sm$Significant_sign) == -1] <- 2 # cold and wet
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == -1 & sign(nexp_exp_lc_sm$Significant_sign) == 0] <- 8
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == -1 & sign(nexp_exp_lc_sm$Significant_sign) == 1] <- 3 # hot and dry
sign_temp_sm[sign(nexp_exp_lc_temp$Significant_sign) == -1 & sign(nexp_exp_lc_sm$Significant_sign) == -1] <- 4 # hot and wet
Climatic_condition_lc <- rep(NA, nr_lc*12)
Climatic_condition_lc[sign_temp_sm == 0] <- "non-significant"
Climatic_condition_lc[sign_temp_sm == 1] <- "cold and dry"
Climatic_condition_lc[sign_temp_sm == 2] <- "cold and wet"
Climatic_condition_lc[sign_temp_sm == 3] <- "hot and dry"
Climatic_condition_lc[sign_temp_sm == 4] <- "hot and wet"
Climatic_condition_lc[sign_temp_sm == 5] <- "dry"
Climatic_condition_lc[sign_temp_sm == 6] <- "wet"
Climatic_condition_lc[sign_temp_sm == 7] <- "cold"
Climatic_condition_lc[sign_temp_sm == 8] <- "hot"
Climatic_condition_lc <- factor(Climatic_condition_lc, levels = c("non-significant", "cold and dry", "cold and wet", "hot and dry", "hot and wet", "dry", "wet", "cold", "hot"))

vul_mon_lc2 <- group_by(vul_mon_lc_all, Month, Landcover, Type) # called vul_mon_lc2, because vul_mon_lc is already defined above
vul_mon_lc_med <- vul_mon_lc2 %>% summarize(Median_Vulnerability = median(Vulnerability, na.rm=T))
vul_mon_lc_mean <- vul_mon_lc2 %>% summarize(Mean_Vulnerability = mean(Vulnerability, na.rm=T))
vul_mon_lc_count <- vul_mon_lc2 %>% summarize(Count_events = sum(!is.nan(Vulnerability)))
vul_mon_lc_low <- vul_mon_lc2 %>% summarize(IQR_low = quantile(Vulnerability, 1/4, na.rm=T))
vul_mon_lc_high <- vul_mon_lc2 %>% summarize(IQR_high = quantile(Vulnerability, 3/4, na.rm=T))
col_vec <- nexp_exp_lc
col_vec <-  col_vec[order(col_vec$Month),] # order so that the colors match
vul_mon_lc_stat <- data.frame(vul_mon_lc_med, Mean_Vulnerability = vul_mon_lc_mean$Mean_Vulnerability, IQR_low = vul_mon_lc_low$IQR_low, IQR_high = vul_mon_lc_high$IQR_high, col_vec %>% select(Sign_color), Count = vul_mon_lc_count$Count_events)
vul_mon_lc_stat <- group_by(vul_mon_lc_stat, Month, Landcover)
ggplot(vul_mon_lc_stat %>% filter(Type=="imp_vul_sm"))+ 
  geom_vline(aes(xintercept = Month, color = Climatic_condition_lc), size = 30)+ # comment out for second legend
  geom_hline(aes(yintercept = 0), color = "grey50", size = 1)+
  scale_colour_manual(values = c("DarkGray", "#44B360", "#3A88B5", "#F7900A", "#993A65", "#9DA135", "#69618D", "#3F9D8A", "#C86537"))+ # comment out for second legend
  # scale_colour_manual(values = c("DarkGray", "#44B360", "#3A88B5", "#F7900A", "#9DA135", "#69618D", "#3F9D8A", "#C86537"))+ # comment out for second legend
  geom_line(data = vul_mon_lc_stat %>% filter(Type=="imp_vul_sm"), aes(Month, Median_Vulnerability, group=1), size=1.4, color = "black")+
  geom_line(data = vul_mon_lc_stat %>% filter(Type=="imp_vul_temp"), aes(Month, Median_Vulnerability, group=1), size=1.4, color = "white")+
  
  # scale_color_manual(labels = c("Soil moisture", "Temperature"), values = c("black", "white"))+ # for second legend
  # geom_line(data = vul_mon_lc_stat %>% filter(Type=="imp_vul_sm"), aes(Month, Median_Vulnerability, group=1, color = "black"), size=1.4)+ # for second legend
  # geom_line(data = vul_mon_lc_stat %>% filter(Type=="imp_vul_temp"), aes(Month, Median_Vulnerability, group=1, color = "white"), size=1.4)+ # for second legend
  
  labs(# y = "Driver combination")+
    y = expression("Median vulnerability V"[E]), 
    color='Vulnerability to \nclimatic condition' # comment out for second legend
    # color='Vulnerability to climatic variable' # for second legend
  )+
  geom_text(data = vul_mon_lc_stat %>% filter(Type=="imp_vul_sm"), aes(Month, 0.5, label = Count, group=1), nudge_x = -0.2, nudge_y = -0.1)+
  facet_wrap(~ Landcover, nrow=nr_lc, ncol=1)+
  theme(axis.text.x = element_text(size = 20),
        axis.text.y = element_text(size = 11),
        axis.title.x = element_text(size = 22),
        axis.title.y = element_text(size = 22),
        legend.text=element_text(size=19),
        legend.title=element_text(size=22),
        strip.text.x = element_text(size = 19),
        plot.margin = unit(c(2, 0, 0, 0), "cm") # to make room for the later added second legend
        # ,legend.position="top" # for second legend
  ) + 
  guides(color = guide_legend(override.aes = list(size = 20.5))) # legend size, comment out for second legend
ggsave(filename=paste0("./Output/Time_series_vulnerability_landcover_month_colored_bivariate_2sample_wilcox_test_8col.pdf"), width = 15, height = 13)
# ggsave(filename=paste0("./Output/Time_series_vulnerability_landcover_month_colored_bivariate_2sample_wilcox_test_8col_second_legend.pdf"), width = 15, height = 13)


# Regions -----------------------------------------------------------------
nexp_exp_reg_temp <- filter(nexp_exp_reg, Type == "imp_vul_temp")
nexp_exp_reg_sm <- filter(nexp_exp_reg, Type == "imp_vul_sm")

sign_temp_sm <- rep(NA, 6*12)
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == 0 & sign(nexp_exp_reg_sm$Significant_sign) == 0] <- 0
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == 0 & sign(nexp_exp_reg_sm$Significant_sign) == 1] <- 5
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == 0 & sign(nexp_exp_reg_sm$Significant_sign) == -1] <- 6
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == 1 & sign(nexp_exp_reg_sm$Significant_sign) == 0] <- 7
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == 1 & sign(nexp_exp_reg_sm$Significant_sign) == 1] <- 1 # cold and dry
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == 1 & sign(nexp_exp_reg_sm$Significant_sign) == -1] <- 2 # cold and wet
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == -1 & sign(nexp_exp_reg_sm$Significant_sign) == 0] <- 8
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == -1 & sign(nexp_exp_reg_sm$Significant_sign) == 1] <- 3 # hot and dry
sign_temp_sm[sign(nexp_exp_reg_temp$Significant_sign) == -1 & sign(nexp_exp_reg_sm$Significant_sign) == -1] <- 4 # hot and wet
Climatic_condition_reg <- rep(NA, nr_lc*6)
Climatic_condition_reg[sign_temp_sm == 0] <- "non-significant"
Climatic_condition_reg[sign_temp_sm == 1] <- "cold and dry"
Climatic_condition_reg[sign_temp_sm == 2] <- "cold and wet"
Climatic_condition_reg[sign_temp_sm == 3] <- "hot and dry"
Climatic_condition_reg[sign_temp_sm == 4] <- "hot and wet"
Climatic_condition_reg[sign_temp_sm == 5] <- "dry"
Climatic_condition_reg[sign_temp_sm == 6] <- "wet"
Climatic_condition_reg[sign_temp_sm == 7] <- "cold"
Climatic_condition_reg[sign_temp_sm == 8] <- "hot"
Climatic_condition_reg <- factor(Climatic_condition_reg, levels = c("non-significant", "cold and dry", "cold and wet", "hot and dry", "hot and wet", "dry", "wet", "cold", "hot"))

vul_mon_reg2 <- group_by(vul_mon_reg_all, Month, Region_ID, Type)
vul_mon_reg_med <- vul_mon_reg2 %>% summarize(Median_Vulnerability = median(Vulnerability, na.rm=T))
vul_mon_reg_count <- vul_mon_reg2 %>% summarize(Count_events = sum(!is.nan(Vulnerability)))
vul_mon_reg_low <- vul_mon_reg2 %>% summarize(IQR_low = quantile(Vulnerability, 1/4, na.rm=T))
vul_mon_reg_high <- vul_mon_reg2 %>% summarize(IQR_high = quantile(Vulnerability, 3/4, na.rm=T))
col_vec <- nexp_exp_reg
col_vec <-  col_vec[order(col_vec$Month),] # order so that the colors match
vul_mon_reg_stat <- data.frame(vul_mon_reg_med, IQR_low = vul_mon_reg_low$IQR_low, IQR_high = vul_mon_reg_high$IQR_high, col_vec %>% select(Sign_color), Count = vul_mon_reg_count$Count_events)
vul_mon_reg_stat <- group_by(vul_mon_reg_stat, Month, Region_ID)
ggplot(vul_mon_reg_stat %>% filter(Type=="imp_vul_sm"))+ 
  geom_vline(aes(xintercept = Month, color = Climatic_condition_reg), size = 30)+ # comment out for second legend
  geom_hline(aes(yintercept = 0), color = "grey50", size = 1)+
  scale_colour_manual(values = c("DarkGray", "#44B360", "#3A88B5", "#F7900A", "#993A65", "#9DA135", "#69618D", "#3F9D8A", "#C86537"))+ # comment out for second legend
  # scale_colour_manual(values = c( "#44B360", "#3A88B5", "#F7900A", "#993A65", "#9DA135", "#69618D", "#3F9D8A", "#C86537"))+ # comment out for second legend
  geom_line(data = vul_mon_reg_stat %>% filter(Type=="imp_vul_sm"), aes(Month, Median_Vulnerability, group=1), size=1.4, color = "black")+
  geom_line(data = vul_mon_reg_stat %>% filter(Type=="imp_vul_temp"), aes(Month, Median_Vulnerability, group=1), size=1.4, color = "white")+
  
  # scale_color_manual(labels = c("Soil moisture", "Temperature"), values = c("black", "white"))+ # for second legend
  # geom_line(data = vul_mon_reg_stat %>% filter(Type=="imp_vul_sm"), aes(Month, Median_Vulnerability, group=1, color = "black"), size=1.4)+ # for second legend
  # geom_line(data = vul_mon_reg_stat %>% filter(Type=="imp_vul_temp"), aes(Month, Median_Vulnerability, group=1, color = "white"), size=1.4)+ # for second legend
  
  labs(y = expression("Median vulnerability V"[E]),  
       color='Vulnerability to \nclimatic condition' # comment out for second legend
       # color='Vulnerability to climatic variable' # for second legend
  )+
  geom_text(data = vul_mon_reg_stat %>% filter(Type=="imp_vul_sm"), aes(Month, 0.5, label = Count, group=1), nudge_x = -0.2)+
  facet_wrap(~ Region_ID, nrow=length(unique(mean_nexp_exp_reg$Region_ID)), ncol=1)+
  theme(axis.text.x = element_text(size = 20),
        axis.text.y = element_text(size = 11),
        axis.title.x = element_text(size = 22),
        axis.title.y = element_text(size = 22),
        legend.text=element_text(size=19),
        legend.title=element_text(size=22),
        strip.text.x = element_text(size = 19),
        plot.margin = unit(c(2, 0, 0, 0), "cm") # to make room for the later added second legend
        # ,legend.position="top" # for second legend
  ) + 
  guides(color = guide_legend(override.aes = list(size = 20.5))) # legend size, comment out for second legend
ggsave(filename=paste0("./Output/Time_series_vulnerability_subregion_month_colored_bivariate_2sample_wilcox_test_8col.pdf"), width = 15, height = 10)
# ggsave(filename=paste0("./Output/Time_series_vulnerability_subregion_month_colored_bivariate_2sample_wilcox_test_8col_second_legend.pdf"), width = 15, height = 10)