# Ecosystem_vulnerability

This readme gives an overview of the code belonging to the article “Seasonal ecosystem vulnerability to climatic anomalies in the Mediterranean”.
The code was created using R version 3.6.


# Code #######

To run the code you need to assign the path, where the created workspaces and the input data are stored on your computer to the variables “path_workspaces” and "path_data” within the respective files.

Preprocessing.R: Cropping, Rescaling, monthly aggregation, deseasonalisation, z-score calculation and calculation of percentiles for the temperature, soil moisture and FAPAR data sets
Rolling_mean_example.R: Calculation of rolling mean (file is available at http://www.cookbook-r.com/Manipulating_data/Calculating_a_moving_average/)
Koeppen_Geiger.R: Creation of Köppen-Geiger map (file is available at http://koeppen-geiger.vu-wien.ac.at/present.htm)
Investigate_sm_NAs.R: Creation of map of soil moisture data availability
Regional_comparisons.R: Assignment of subregion to each pixel
Land_cover.Rmd: Assignment of land cover class to each pixel and identification of pixels with land cover change
Vulnerability_analysis.Rmd: Calculation of monthly vulnerability and creation of an illustrative schematic plot of the vulnerability analysis
Bivariate_map_seasonal.Rmd: Creation of the spatial bivariate vulnerability maps 
Monthly_assessment.R: Creation of time series plots of monthly vulnerability


# Data #######

Temperature data from ERA5 Land is available here: https://cds.climate.copernicus.eu/cdsapp#!/dataset/reanalysis-era5-land-monthly-means?tab=form
Soil moisture data from ERA5 Land is available here: https://cds.climate.copernicus.eu/cdsapp#!/dataset/reanalysis-era5-land-monthly-means?tab=form
Soil moisture data from ESA CCI is available here: https://www.esa-soilmoisture-cci.org/node/145
Land cover data is available here: https://maps.elie.ucl.ac.be/CCI/viewer/download.php
The Köppen-Geiger map is available here: http://koeppen-geiger.vu-wien.ac.at/present.htm
National borders are obtained from: https://www.naturalearthdata.com/downloads/50m-cultural-vectors/50m-admin-0-countries-2/
sm79_19_monthly.nc: This file is created from the soil moisture data from ESA CCI using cdo (commands applied: merge, crop, monmean, mergetime) and contains the soil moisture data monthly aggregated from 1979 to 2019 for the Mediterranean Basin. It can also be created with Preprocessing.R.